git-commit.sh 13.7 KB
Newer Older
L
Linus Torvalds 已提交
1
#!/bin/sh
2 3
#
# Copyright (c) 2005 Linus Torvalds
4 5
# Copyright (c) 2006 Junio C Hamano

6
USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit>] [-e] [--author <author>] [[-i | -o] <path>...]'
7
SUBDIRECTORY_OK=Yes
8
. git-sh-setup
9

J
Junio C Hamano 已提交
10 11 12 13 14 15 16 17 18 19 20
git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
branch=$(GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD)

case "$0" in
*status)
	status_only=t
	unmerged_ok_if_status=--unmerged ;;
*commit)
	status_only=
	unmerged_ok_if_status= ;;
esac
21 22 23 24 25 26 27

refuse_partial () {
	echo >&2 "$1"
	echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
	exit 1
}

J
Junio C Hamano 已提交
28 29 30
THIS_INDEX="$GIT_DIR/index"
NEXT_INDEX="$GIT_DIR/next-index$$"
rm -f "$NEXT_INDEX"
J
Junio C Hamano 已提交
31
save_index () {
J
Junio C Hamano 已提交
32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59
	cp "$THIS_INDEX" "$NEXT_INDEX"
}

report () {
  header="#
# $1:
#   ($2)
#
"
  trailer=""
  while read status name newname
  do
    printf '%s' "$header"
    header=""
    trailer="#
"
    case "$status" in
    M ) echo "#	modified: $name";;
    D*) echo "#	deleted:  $name";;
    T ) echo "#	typechange: $name";;
    C*) echo "#	copied: $name -> $newname";;
    R*) echo "#	renamed: $name -> $newname";;
    A*) echo "#	new file: $name";;
    U ) echo "#	unmerged: $name";;
    esac
  done
  printf '%s' "$trailer"
  [ "$header" ]
J
Junio C Hamano 已提交
60 61 62
}

run_status () {
J
Junio C Hamano 已提交
63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89
    (
	# We always show status for the whole tree.
	cd "$TOP"

	# If TMP_INDEX is defined, that means we are doing
	# "--only" partial commit, and that index file is used
	# to build the tree for the commit.  Otherwise, if
	# NEXT_INDEX exists, that is the index file used to
	# make the commit.  Otherwise we are using as-is commit
	# so the regular index file is what we use to compare.
	if test '' != "$TMP_INDEX"
	then
	    GIT_INDEX_FILE="$TMP_INDEX"
	    export GIT_INDEX_FILE
	elif test -f "$NEXT_INDEX"
	then
	    GIT_INDEX_FILE="$NEXT_INDEX"
	    export GIT_INDEX_FILE
	fi

	case "$branch" in
	refs/heads/master) ;;
	*)  echo "# On branch $branch" ;;
	esac

	if test -z "$initial_commit"
	then
90 91 92 93 94 95 96
	    git-diff-index -M --cached --name-status \
		--diff-filter=MDTCRA HEAD |
	    sed -e '
		    s/\\/\\\\/g
		    s/ /\\ /g
	    ' |
	    report "Updated but not checked in" "will commit"
J
Junio C Hamano 已提交
97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146
	    committable="$?"
	else
	    echo '#
# Initial commit
#'
	    git-ls-files |
	    sed -e '
		    s/\\/\\\\/g
		    s/ /\\ /g
		    s/^/A /
	    ' |
	    report "Updated but not checked in" "will commit"

	    committable="$?"
	fi

	git-diff-files  --name-status |
	sed -e '
		s/\\/\\\\/g
		s/ /\\ /g
	' |
	report "Changed but not updated" \
	    "use git-update-index to mark for commit"

	if test -f "$GIT_DIR/info/exclude"
	then
	    git-ls-files -z --others --directory \
		--exclude-from="$GIT_DIR/info/exclude" \
		--exclude-per-directory=.gitignore
	else
	    git-ls-files -z --others --directory \
		--exclude-per-directory=.gitignore
	fi |
	perl -e '$/ = "\0";
	    my $shown = 0;
	    while (<>) {
		chomp;
		s|\\|\\\\|g;
		s|\t|\\t|g;
		s|\n|\\n|g;
		s/^/#	/;
		if (!$shown) {
		    print "#\n# Untracked files:\n";
		    print "#   (use \"git add\" to add to commit)\n";
		    print "#\n";
		    $shown = 1;
		}
		print "$_\n";
	    }
	'
147 148 149 150 151

	if test -n "$verbose"
	then
	    git-diff-index --cached -M -p --diff-filter=MDTCRA HEAD
	fi
J
Junio C Hamano 已提交
152 153 154 155 156 157 158
	case "$committable" in
	0)
	    echo "nothing to commit"
	    exit 1
	esac
	exit 0
    )
J
Junio C Hamano 已提交
159 160
}

J
Junio C Hamano 已提交
161 162 163 164 165 166 167 168 169 170
trap '
	test -z "$TMP_INDEX" || {
		test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
	}
	rm -f "$NEXT_INDEX"
' 0

################################################################
# Command line argument parsing and sanity checking

171 172
all=
also=
J
Junio C Hamano 已提交
173
only=
174 175 176 177 178 179
logfile=
use_commit=
no_edit=
log_given=
log_message=
verify=t
J
Junio C Hamano 已提交
180
verbose=
181 182
signoff=
force_author=
183
only_include_assumed=
184
while case "$#" in 0) break;; esac
185
do
186
  case "$1" in
187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206
  -F|--F|-f|--f|--fi|--fil|--file)
      case "$#" in 1) usage ;; esac
      shift
      no_edit=t
      log_given=t$log_given
      logfile="$1"
      shift
      ;;
  -F*|-f*)
      no_edit=t
      log_given=t$log_given
      logfile=`expr "$1" : '-[Ff]\(.*\)'`
      shift
      ;;
  --F=*|--f=*|--fi=*|--fil=*|--file=*)
      no_edit=t
      log_given=t$log_given
      logfile=`expr "$1" : '-[^=]*=\(.*\)'`
      shift
      ;;
207
  -a|--a|--al|--all)
208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228
      all=t
      shift
      ;;
  --au=*|--aut=*|--auth=*|--autho=*|--author=*)
      force_author=`expr "$1" : '-[^=]*=\(.*\)'`
      shift
      ;;
  --au|--aut|--auth|--autho|--author)
      case "$#" in 1) usage ;; esac
      shift
      force_author="$1"
      shift
      ;;
  -e|--e|--ed|--edi|--edit)
      no_edit=
      shift
      ;;
  -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
      also=t
      shift
      ;;
J
Junio C Hamano 已提交
229 230 231 232
  -o|--o|--on|--onl|--only)
      only=t
      shift
      ;;
233
  -m|--m|--me|--mes|--mess|--messa|--messag|--message)
234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265
      case "$#" in 1) usage ;; esac
      shift
      log_given=t$log_given
      log_message="$1"
      no_edit=t
      shift
      ;;
  -m*)
      log_given=t$log_given
      log_message=`expr "$1" : '-m\(.*\)'`
      no_edit=t
      shift
      ;;
  --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
      log_given=t$log_given
      log_message=`expr "$1" : '-[^=]*=\(.*\)'`
      no_edit=t
      shift
      ;;
  -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|--no-verify)
      verify=
      shift
      ;;
  -c)
      case "$#" in 1) usage ;; esac
      shift
      log_given=t$log_given
      use_commit="$1"
      no_edit=
      shift
      ;;
  --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
266 267
  --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
  --reedit-messag=*|--reedit-message=*)
268 269 270 271 272 273
      log_given=t$log_given
      use_commit=`expr "$1" : '-[^=]*=\(.*\)'`
      no_edit=
      shift
      ;;
  --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
274
  --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|--reedit-message)
275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290
      case "$#" in 1) usage ;; esac
      shift
      log_given=t$log_given
      use_commit="$1"
      no_edit=
      shift
      ;;
  -C)
      case "$#" in 1) usage ;; esac
      shift
      log_given=t$log_given
      use_commit="$1"
      no_edit=t
      shift
      ;;
  --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
291 292
  --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
  --reuse-message=*)
293 294 295 296 297 298
      log_given=t$log_given
      use_commit=`expr "$1" : '-[^=]*=\(.*\)'`
      no_edit=t
      shift
      ;;
  --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
299
  --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
300 301 302 303 304 305 306
      case "$#" in 1) usage ;; esac
      shift
      log_given=t$log_given
      use_commit="$1"
      no_edit=t
      shift
      ;;
307
  -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
308 309 310
      signoff=t
      shift
      ;;
J
Junio C Hamano 已提交
311 312 313
  -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
      verbose=t
      shift
314
      ;;
315
  --)
316 317 318
      shift
      break
      ;;
319
  -*)
320 321
      usage
      ;;
322
  *)
323 324
      break
      ;;
325
  esac
326 327
done

J
Junio C Hamano 已提交
328 329 330
################################################################
# Sanity check options

331 332 333 334 335
case "$log_given" in
tt*)
  die "Only one of -c/-C/-F/-m can be used." ;;
esac

J
Junio C Hamano 已提交
336 337 338 339 340 341 342 343
case "$#,$also$only" in
*,tt)
  die "Only one of --include/--only can be used." ;;
0,t)
  die "No paths with --include/--only does not make sense." ;;
0,)
  ;;
*,)
J
Junio C Hamano 已提交
344
  only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
345
  also=
J
Junio C Hamano 已提交
346 347 348
  ;;
esac
unset only
J
Junio C Hamano 已提交
349 350 351 352 353 354 355 356 357 358 359
case "$all,$also,$#" in
t,t,*)
	die "Cannot use -a and -i at the same time." ;;
t,,[1-9]*)
	die "Paths with -a does not make sense." ;;
,t,0)
	die "No paths with -i does not make sense." ;;
esac

################################################################
# Prepare index to have a tree to be committed
J
Junio C Hamano 已提交
360

361
TOP=`git-rev-parse --show-cdup`
J
Junio C Hamano 已提交
362 363 364 365
if test -z "$TOP"
then
	TOP=./
fi
366 367 368

case "$all,$also" in
t,)
J
Junio C Hamano 已提交
369
	save_index &&
370
	(
J
Junio C Hamano 已提交
371
		cd "$TOP"
J
Junio C Hamano 已提交
372 373
		GIT_INDEX_FILE="$NEXT_INDEX"
		export GIT_INDEX_FILE
374 375 376
		git-diff-files --name-only -z |
		git-update-index --remove -z --stdin
	)
J
Junio C Hamano 已提交
377
	;;
378
,t)
J
Junio C Hamano 已提交
379
	save_index &&
380 381
	git-ls-files --error-unmatch -- "$@" >/dev/null || exit

382
	git-diff-files --name-only -z -- "$@"  |
J
Junio C Hamano 已提交
383 384 385 386 387 388
	(
		cd "$TOP"
		GIT_INDEX_FILE="$NEXT_INDEX"
		export GIT_INDEX_FILE
		git-update-index --remove -z --stdin
	)
389
	;;
390 391 392 393 394 395 396 397 398 399 400 401 402 403 404
,)
	case "$#" in
	0)
	    ;; # commit as-is
	*)
	    if test -f "$GIT_DIR/MERGE_HEAD"
	    then
		refuse_partial "Cannot do a partial commit during a merge."
	    fi
	    TMP_INDEX="$GIT_DIR/tmp-index$$"
	    if test -z "$initial_commit"
	    then
		# make sure index is clean at the specified paths, or
		# they are additions.
		dirty_in_index=`git-diff-index --cached --name-status \
J
Junio C Hamano 已提交
405
			--diff-filter=DMTU HEAD -- "$@"`
406
		test -z "$dirty_in_index" ||
J
Junio C Hamano 已提交
407
		refuse_partial "Different in index and the last commit:
408 409
$dirty_in_index"
	    fi
410
	    commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
J
Junio C Hamano 已提交
411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433

	    # Build the temporary index and update the real index
	    # the same way.
	    if test -z "$initial_commit"
	    then
		cp "$THIS_INDEX" "$TMP_INDEX"
		GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
	    else
		    rm -f "$TMP_INDEX"
	    fi || exit

	    echo "$commit_only" |
	    GIT_INDEX_FILE="$TMP_INDEX" \
	    git-update-index --add --remove --stdin &&

	    save_index &&
	    echo "$commit_only" |
	    (
		GIT_INDEX_FILE="$NEXT_INDEX"
		export GIT_INDEX_FILE
		git-update-index --remove --stdin
	    ) || exit
	    ;;
434 435 436 437
	esac
	;;
esac

J
Junio C Hamano 已提交
438 439 440 441
################################################################
# If we do as-is commit, the index file will be THIS_INDEX,
# otherwise NEXT_INDEX after we make this commit.  We leave
# the index as is if we abort.
442

J
Junio C Hamano 已提交
443
if test -f "$NEXT_INDEX"
444
then
J
Junio C Hamano 已提交
445 446 447
	USE_INDEX="$NEXT_INDEX"
else
	USE_INDEX="$THIS_INDEX"
448 449
fi

J
Junio C Hamano 已提交
450 451 452 453 454 455 456 457 458 459 460 461 462 463 464
GIT_INDEX_FILE="$USE_INDEX" \
    git-update-index -q $unmerged_ok_if_status --refresh || exit

################################################################
# If the request is status, just show it and exit.

case "$0" in
*status)
	run_status
	exit $?
esac

################################################################
# Grab commit message, write out tree and make commit.

465 466 467 468 469 470
if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
then
	if test "$TMP_INDEX"
	then
		GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
	else
J
Junio C Hamano 已提交
471
		GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
472 473
	fi || exit
fi
474

475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490
if test "$log_message" != ''
then
	echo "$log_message"
elif test "$logfile" != ""
then
	if test "$logfile" = -
	then
		test -t 0 &&
		echo >&2 "(reading log message from standard input)"
		cat
	else
		cat <"$logfile"
	fi
elif test "$use_commit" != ""
then
	git-cat-file commit "$use_commit" | sed -e '1,/^$/d'
491 492 493
elif test -f "$GIT_DIR/MERGE_HEAD" && test -f "$GIT_DIR/MERGE_MSG"
then
	cat "$GIT_DIR/MERGE_MSG"
494
fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
495 496 497

case "$signoff" in
t)
498 499 500 501 502 503
	{
		echo
		git-var GIT_COMMITTER_IDENT | sed -e '
			s/>.*/>/
			s/^/Signed-off-by: /
		'
504
	} >>"$GIT_DIR"/COMMIT_EDITMSG
505 506 507 508 509
	;;
esac

if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
	echo "#"
A
Alex Riesen 已提交
510
	echo "# It looks like you may be committing a MERGE."
511 512 513 514
	echo "# If this is not correct, please remove the file"
	echo "#	$GIT_DIR/MERGE_HEAD"
	echo "# and try again"
	echo "#"
515
fi >>"$GIT_DIR"/COMMIT_EDITMSG
516

517
# Author
J
Junio C Hamano 已提交
518 519 520 521 522 523 524 525 526
if test '' != "$force_author"
then
	GIT_AUTHOR_NAME=`expr "$force_author" : '\(.*[^ ]\) *<.*'` &&
	GIT_AUTHOR_EMAIL=`expr "$force_author" : '.*\(<.*\)'` &&
	test '' != "$GIT_AUTHOR_NAME" &&
	test '' != "$GIT_AUTHOR_EMAIL" ||
	die "malformatted --author parameter"
	export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
elif test '' != "$use_commit"
527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556
then
	pick_author_script='
	/^author /{
		s/'\''/'\''\\'\'\''/g
		h
		s/^author \([^<]*\) <[^>]*> .*$/\1/
		s/'\''/'\''\'\'\''/g
		s/.*/GIT_AUTHOR_NAME='\''&'\''/p

		g
		s/^author [^<]* <\([^>]*\)> .*$/\1/
		s/'\''/'\''\'\'\''/g
		s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p

		g
		s/^author [^<]* <[^>]*> \(.*\)$/\1/
		s/'\''/'\''\'\'\''/g
		s/.*/GIT_AUTHOR_DATE='\''&'\''/p

		q
	}
	'
	set_author_env=`git-cat-file commit "$use_commit" |
	LANG=C LC_ALL=C sed -ne "$pick_author_script"`
	eval "$set_author_env"
	export GIT_AUTHOR_NAME
	export GIT_AUTHOR_EMAIL
	export GIT_AUTHOR_DATE
fi

557
PARENTS="-p HEAD"
558
if test -z "$initial_commit"
J
Junio C Hamano 已提交
559
then
560
	if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
J
Junio C Hamano 已提交
561
		PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
562
	fi
J
Junio C Hamano 已提交
563 564
else
	if [ -z "$(git-ls-files)" ]; then
J
Junio C Hamano 已提交
565
		echo >&2 Nothing to commit
J
Junio C Hamano 已提交
566 567 568
		exit 1
	fi
	PARENTS=""
569
fi
570

571 572 573 574
{
	test -z "$only_include_assumed" || echo "$only_include_assumed"
	run_status
} >>"$GIT_DIR"/COMMIT_EDITMSG
S
Santi_Béjar 已提交
575
if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" ]
L
Linus Torvalds 已提交
576
then
577
	rm -f "$GIT_DIR/COMMIT_EDITMSG"
J
Junio C Hamano 已提交
578
	run_status
L
Linus Torvalds 已提交
579 580
	exit 1
fi
581
case "$no_edit" in
582
'')
583 584 585 586 587 588
	case "${VISUAL:-$EDITOR},$TERM" in
	,dumb)
		echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
		echo >&2 "Please supply the commit log message using either"
		echo >&2 "-m or -F option.  A boilerplate log message has"
		echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
589 590
		exit 1
		;;
591
	esac
592
	${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
593 594
	;;
esac
595 596 597 598 599

case "$verify" in
t)
	if test -x "$GIT_DIR"/hooks/commit-msg
	then
600
		"$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
601 602 603
	fi
esac

J
Junio C Hamano 已提交
604
sed -e '
605 606 607 608 609
    /^diff --git a\/.*/{
	s///
	q
    }
    /^#/d
J
Junio C Hamano 已提交
610 611
' "$GIT_DIR"/COMMIT_EDITMSG |
git-stripspace >"$GIT_DIR"/COMMIT_MSG
612 613 614 615 616

if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
	git-stripspace |
	wc -l` &&
   test 0 -lt $cnt
617
then
618 619
	if test -z "$TMP_INDEX"
	then
J
Junio C Hamano 已提交
620
		tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
621 622 623 624
	else
		tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
		rm -f "$TMP_INDEX"
	fi &&
625
	commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
J
Junio C Hamano 已提交
626
	git-update-ref HEAD $commit $current &&
J
Junio C Hamano 已提交
627 628 629 630 631 632 633
	rm -f -- "$GIT_DIR/MERGE_HEAD" &&
	if test -f "$NEXT_INDEX"
	then
		mv "$NEXT_INDEX" "$THIS_INDEX"
	else
		: ;# happy
	fi
634 635 636 637
else
	echo >&2 "* no commit message?  aborting commit."
	false
fi
638
ret="$?"
639
rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG"
640 641 642 643
if test -d "$GIT_DIR/rr-cache"
then
	git-rerere
fi
644 645 646 647 648

if test -x "$GIT_DIR"/hooks/post-commit && test "$ret" = 0
then
	"$GIT_DIR"/hooks/post-commit
fi
649
exit "$ret"